/*
 This works on the Uno  
 In this version I will modify step calculation
 4x4 matrix keypad amd a 20 x 4 LCD. 
 Edit Rotation & TableRatio(# of turns for 360 degrees)in line 29
 A4988 Stepstick/Pololu driver 
 5/2/2015
 */
// **************define Debug Macro**************
//#define DEBUG 1    //delete slashes for printing debug info to serial monitor
#ifdef DEBUG
  #define DEBUG_Print(x)  Serial.print(x)
  #define DEBUG_PrintDec(x,y) Serial.print(x,y)
  #define DEBUG_Println(x) Serial.println(x)
#else
  #define DEBUG_Print(x)  
  #define DEBUG_PrintDec(x,y)
  #define DEBUG_Println(x) 
#endif

 #include <Wire.h> 
 #include <LiquidCrystal_I2C.h>
 #include <Keypad.h>
 #include <EEPROM.h>
 const byte ROWS = 4;
 const byte COLS = 4;
//****************USER DEFINED**************
//setup vars
         
  int StepsPerRotation = 400; // Set Steps per rotation of stepper NOTE the driver is set to Half step
  int TableRatio = 72;        // ratio of rotary table
  int stepdelay = 1000;  //this is in microseconds
 int delay1 = 2000;  //this is used for initial Splash Screen display time 
 const int delay2 = 500;  //this is used for subsequent Splash screens
 char key;

//**For pro micro
/*    const int stp = 8;               // connect pin D8 to step
      const int dir = 9;      // connect pin D9 to dir
      byte colPINS[ROWS] = {18,19,20,21};  //pin 1 of keypad to pin 10
      byte rowPINS[COLS] = {10,16,14,15};*/
//**************

 ///*for UNO
   const int stp = 2;             
    const int dir = 3;  
    byte colPINS[ROWS] = {9,10,11,12};  //pin 1 of keypad to pin 12
    byte rowPINS[COLS] = {5,6,7,8};
//***************
 
 LiquidCrystal_I2C lcd(0x27,20,4); // set the LCD address as determined by I2C scanner
                                   // SCL - A5, SDA - A4, VCC - +5, Gnd - Gnd 
//***********************************************



 int isteps, itable;

 char keys[ROWS][COLS] = {
 {'1','2','3','A'},
 {'4','5','6','B'},
 {'7','8','9','C'},
 {'.','0','#','D'}
 };


 Keypad kpd = Keypad(makeKeymap(keys),rowPINS,colPINS, ROWS, COLS);

 
 int moved;
 long Multiplier;


 long cumSteps = 0;
 float Degrees = 0.;                // Degrees from keypad
 long ToMove = 0;  // Steps to move

 float bob = 0.;  //this tracks current position in degrees

 int cho = 0;

 void setup()
 {   

  lcd.init();      // initialize the lcd 
  lcd.backlight();
  EEPROM.get(0,TableRatio);
  EEPROM.get(2,StepsPerRotation);
  EEPROM.get(4,stepdelay);


 //from EEPROM
   #ifdef DEBUG 
   Serial.begin(115200); 
  #endif

   pinMode(stp, OUTPUT);
 pinMode(dir, OUTPUT); 

 // Print welcome message to the LCD.
 
 lcd.print("Rotary Table Control");

 lcd.setCursor(3,3);
 lcd.print("EEPROM 2018");
 delay(delay1);
 
 

   /*check if key pad A is held down if it is
   * then jump to getRatios and input new rations
   */
int i=0;

key = kpd.getKey();
    
  

        DEBUG_Print("EEPROM Table = "); DEBUG_Print(TableRatio);DEBUG_Println(":1");
         DEBUG_Print("EEPROM Steps = ");  DEBUG_Println(StepsPerRotation);
          DEBUG_Print("EEPROM Deelay = ");  DEBUG_Println(stepdelay);
       
 delay1=delay2;
 lcd.init();
 //*****************************************

   cho = 0;
   // *************************************************

  key = kpd.getKey();
  /* lcd.print("Enter Selection:");  
   lcd.setCursor(0,1); 
   lcd.print("Degrees      = A");  
   lcd.setCursor(0,2);
   lcd.print("Divisions    = B");
   lcd.setCursor(0,3);
   lcd.print("JOG          = C");*/


   lcd.setCursor(0,0); 
   lcd.print("Degrees      = A");  
   lcd.setCursor(0,1);
   lcd.print("Divisions    = B");
   lcd.setCursor(0,2);
   lcd.print("JOG          = C");
   lcd.setCursor(0,3);
   lcd.print("Settings     = D");
   while(cho == 0)
   {
     key = kpd.getKey();
     switch (key)
     {
     case NO_KEY:
      break;
     case 'A':
       Degrees=getdegrees();
       lcd.clear();

       cho = 1;
       break; 
     case 'B':
       Degrees=getdivisions();  
       cho=2;
       break;
     case 'C':
       Degrees=getjog();
       lcd.clear();
       cho=3;
       break;
      case 'D':
       Settings();
        EEPROM.get(0,TableRatio);
        EEPROM.get(2,StepsPerRotation);
        EEPROM.get(4,stepdelay);
       lcd.clear();
       cho=0;
       lcd.setCursor(0,0); 
       lcd.print("Degrees      = A");  
       lcd.setCursor(0,1);
       lcd.print("Divisions    = B");
       lcd.setCursor(0,2);
       lcd.print("JOG          = C");
       lcd.setCursor(0,3);
       lcd.print("Settings     = D");
       break;
       
       }      // end case
     }      // end while cho=0
     
     DEBUG_Print("Table Ratio = "); DEBUG_Println(TableRatio);
     DEBUG_Print("Steps per Rotation = "); DEBUG_Println(StepsPerRotation);
      Multiplier = (long)TableRatio * StepsPerRotation; 
     DEBUG_Print("Multiplier = "); DEBUG_Println(Multiplier); 
         
     
 }    // end setup
 
 void loop()      // MAIN LOOP
 {
   lcd.clear();  
   char key = kpd.getKey();

     bob = 0;
    
     cumSteps=0;
     lcd.setCursor(7,0);lcd.print("Total:  ");lcd.print("       ");lcd.setCursor(14,0);lcd.print(bob,2);   // total steps
     
     lcd.setCursor(0,3);lcd.print("FOR=A   REV=B    X=C");
   while(key != 'C')    // C will return to start menu
   {
     lcd.setCursor(0,0);lcd.print(abs(Degrees),2);lcd.print((char)223);
     key = kpd.getKey();
        if (key !=NULL){DEBUG_Print("Key is ");DEBUG_Println(key);}
     if(key == 'A')            // FORWARD
       {
      
        bob = bob + Degrees;
       
        ToMove=(long)((float)(bob/360 * Multiplier + 0.5 - cumSteps));
           
        cumSteps=cumSteps+ToMove;

        digitalWrite(dir, LOW);
        printadvance();
        
       }
     if(key=='B')              // REVERSE
       { 

        bob = bob - Degrees;  
        ToMove=(long)((float)(cumSteps+0.5 -  (bob * Multiplier)/360));

        cumSteps=cumSteps-ToMove;
       

         

        digitalWrite(dir, HIGH);    // pin 13
        printadvance();  
       }
   }      // end while not C loop
   lcd.init();
  setup();
 }      // end main VOID
 


float getjog()  // used to set mechanical ratio and steps per revelution
{
  float Degrees = 0;
  float num = 0.00;
   char key = kpd.getKey();
   lcd.clear();
   lcd.setCursor(6,0);lcd.print("Jogging");
   lcd.setCursor(0,1);lcd.print("A=1 B=5 C=25 Degrees");
   lcd.setCursor(0,2);lcd.print("Choose Degrees:");lcd.setCursor(0,3);lcd.print("OK = #       ");lcd.print((char)60);lcd.print((char)45);lcd.print(" D");

   while(key != '#')
   {
      switch (key)
      {
         case NO_KEY:
            break;
         case 'A':
            Degrees = 1;      
            lcd.setCursor(16,2);lcd.print(Degrees,1);
            break;
         case 'B':
            Degrees = 5;
            lcd.setCursor(16,2);lcd.print(Degrees,1);
            break;
         case 'C':
            Degrees = 25;
            lcd.setCursor(16,2);lcd.print(Degrees,1);
            break;
         case 'D':
          num=0.00;
          lcd.setCursor(15,2);lcd.print("     ");
          lcd.setCursor(15,2);
          break;
      }
      key = kpd.getKey();
   }
  return Degrees; 
}

 
float getdivisions()
{
  float Degrees = 0; 
  float num = 0.00;
   char key = kpd.getKey();
   lcd.clear();
   lcd.setCursor(0,1);lcd.print("Enter Division:");
   lcd.setCursor(0,3);lcd.print("OK = #       ");
   lcd.print((char)60);lcd.print((char)45);lcd.print(" D");
   lcd.setCursor(16,1);

   while(key != '#')
   {
      switch (key)
      {
         case NO_KEY:
            break;
            
         case '0': case '1': case '2': case '3': case '4':
         case '5': case '6': case '7': case '8': case '9':
            num = num * 10 + (key - '0');
            lcd.print(key);
            break;
        
        case 'D':
          num=0.00;
          lcd.setCursor(16,1);lcd.print("     ");
          lcd.setCursor(16,1);
          break;
      }
      Degrees = (float)(360/num);
      key = kpd.getKey();
   }
  return Degrees;  //num;
}


float getdegrees()
{ 
   //int key = 0;
   float num = 0.00;
   float decimal = 0.00;
   float decnum = 0.00;
   int counter = 0;
   lcd.clear();
   //lcd.init();
   char key = kpd.getKey();
   lcd.setCursor(0,1);lcd.print("Enter Degrees:");lcd.setCursor(0,3);lcd.print("OK = #       ");lcd.print((char)60);lcd.print((char)45);lcd.print(" D");
   lcd.setCursor(15,1);
   bool decOffset = false;

   while(key != '#')
   {
      switch (key)
      {
         case NO_KEY:
            break;
            
         case '.':
           if(!decOffset)
           {
             decOffset = true;
           }
            lcd.print(key);
            break;   
         
         case 'D':
          num=0.00;
          lcd.setCursor(15,1);lcd.print("     ");
          lcd.setCursor(15,1);
          break;
         
         case '0': case '1': case '2': case '3': case '4':
         case '5': case '6': case '7': case '8': case '9':
         if(!decOffset)
         {
            num = num * 10 + (key - '0');
            lcd.print(key);
         }
         else if((decOffset) && (counter <= 1))
         {
            num = num * 10 + (key - '0');
            lcd.print(key);
            counter++;
         }
            break;
      }    //end case
      decnum = num / pow(10, counter);
      key = kpd.getKey();
   }    //end while not #
    return decnum;
}      // end getdegrees
 
 void printadvance()      // print function
   {
     lcd.setCursor(6,1);lcd.print("Moving");
     lcd.setCursor(4,2);lcd.print("Steps  ");lcd.print(ToMove);lcd.setCursor(13,0); lcd.print("       ");
     lcd.setCursor(14,0);lcd.print(bob,2);
     rotation(ToMove,0);
     lcd.setCursor(6,1);lcd.print("      "); 
  } 

 void rotation(long tm, int d)
   { 
     DEBUG_Print("Total Degrees = "); DEBUG_PrintDec(bob,3); DEBUG_Print("   Steps to move = "); DEBUG_Print(tm); DEBUG_Print("  Total Steps = "); DEBUG_Println(cumSteps); 
     
     for(long i = 0; i < tm; i++) 
       { 
       
       
       digitalWrite(stp, HIGH); 
       delayMicroseconds(stepdelay); 
       digitalWrite(stp, LOW); 
       delayMicroseconds(stepdelay); 
       }

       
   }

void software_Reset() // Restarts program from beginning but does not reset the peripherals and registers
  {
  asm volatile ("  jmp 0");  
  } 
   // get first value  Table Ratio
   
 void Settings()
 {

 //first get Table Ratio
 lcd.clear();  
  lcd.setCursor(0,0);lcd.print("TableRatio = ");
  TableRatio = getInt(TableRatio);
    DEBUG_Print("New Table = "); DEBUG_Print(TableRatio);DEBUG_Println(":1");

  //Now get steps per Rev
 lcd.clear();  
 lcd.setCursor(0,0);lcd.print("Steps per Rev = ");
  StepsPerRotation = getInt(StepsPerRotation);
         DEBUG_Print("New Steps = ");     DEBUG_Println(StepsPerRotation);  
         
//Now get step delay
   lcd.clear();  
   lcd.setCursor(0,0);lcd.print("Step delay = ");
  stepdelay = getInt(stepdelay);
     DEBUG_Print("New Delay = ");     DEBUG_Println(stepdelay); 
     
     lcd.clear();
      EEPROM.put(0,TableRatio);
     EEPROM.put(2,StepsPerRotation);
     EEPROM.put(4,stepdelay);

}

  int getInt(int curVal){
  int newVal ;
  
  lcd.print(curVal);
   lcd.setCursor(0,1);lcd.print("New value ");
   lcd.setCursor(0,3);lcd.print("OK = #       ");
   lcd.print((char)60);lcd.print((char)45);lcd.print(" D");
   lcd.setCursor(10,1);
   delay(500);
   newVal=0;

key = kpd.getKey(); 

while(key != '#')
   {
      switch (key)
      {
         case NO_KEY:
            break;
            
         case '0': case '1': case '2': case '3': case '4':
         case '5': case '6': case '7': case '8': case '9':
            newVal = newVal* 10 + (key - '0');
            lcd.print(key);
           break;
        
        case 'D':
          newVal=0;
          lcd.setCursor(9,1);lcd.print("         ");
          lcd.setCursor(10,1);
          break;
      }
     key = kpd.getKey(); 
   }
   if (newVal ==0)
   { newVal = curVal;}
   
      DEBUG_Print("newVal = ");     DEBUG_Println(newVal);  
    return newVal;
}


